//+------------------------------------------------------------------+
//|                                           StochasticDiNapoli.mq4 |
//|                           Copyright  2006, TrendLaboratory Ltd. |
//|            http://finance.groups.yahoo.com/group/TrendLaboratory |
//|                                       E-mail: igorad2004@list.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2005, TrendLaboratory Ltd."
#property link      "http://finance.groups.yahoo.com/group/TrendLaboratory"

#property indicator_separate_window
#property indicator_minimum 0
#property indicator_maximum 100
#property indicator_level1 30
#property indicator_level2 70
#property indicator_buffers 2
#property indicator_color1 DodgerBlue
#property indicator_color2 Orange

extern int    FastK           = 8;
extern int    SlowK           = 3;
extern int    SlowD           = 3;
extern string note            = "turn on Alert = true; turn off = false";
extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = false;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = true;
extern bool   alertsNotify    = false;
extern bool   alertsEmail     = false;
extern string soundFile       = "alert2.wav";

extern bool   LinesVisible    = true;
extern string LinesID         = "StoDiNap";
extern color  LinesUpColor    = LimeGreen;
extern color  LinesDnColor    = OrangeRed;
extern int    LinesStyle      = STYLE_SOLID;
extern int    LinesWidth      = 0;


double StoBuffer[];
double SigBuffer[];
double trend[];
string shortName;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+

int init()
{
   IndicatorBuffers(3);
   SetIndexBuffer(0,StoBuffer); SetIndexLabel(0,"Stoch");
   SetIndexBuffer(1,SigBuffer); SetIndexLabel(1,"Signal"); 
   SetIndexBuffer(2,trend);
   shortName = LinesID+" Stochastic DiNapoli("+FastK+","+SlowK+","+SlowD+")";
   IndicatorShortName(shortName);
return(0);
}

int deinit()
{
   string find = LinesID+":";
   for (int i=ObjectsTotal()-1; i>= 0; i--)
   {
      string name = ObjectName(i); if (StringFind(name,find)==0) ObjectDelete(name);
   }
return(0); 
}

//+------------------------------------------------------------------+
//| Stochastic DiNapoli                                              |
//+------------------------------------------------------------------+

int start()
{
   int counted_bars = IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars > 0) counted_bars--;
           int limit = MathMin(Bars-counted_bars,Bars-1);
           int window = WindowFind(shortName);

   //
   //
   //
   //
   //
   
   for(int i=limit; i>=0; i--)
   { 
      double  low = Low[iLowest(NULL,0,MODE_LOW,FastK,i)]; 
      double high = High[iHighest(NULL,0,MODE_HIGH,FastK,i)];     
      double Fast = (Close[i]-low)/(high-low)*100;
            StoBuffer[i] = StoBuffer[i+1]+(Fast-StoBuffer[i+1])/SlowK;
            SigBuffer[i] = SigBuffer[i+1]+(StoBuffer[i]-SigBuffer[i+1])/SlowD;
            trend[i] = trend[i+1];
            if (StoBuffer[i]>SigBuffer[i]) trend[i] = 1;
            if (StoBuffer[i]<SigBuffer[i]) trend[i] =-1;
            
            //
            //
            //
            //
            //
            
            if (LinesVisible && window>-1)
 	         {
 	            string name = LinesID+":"+Time[i];
 	               ObjectDelete(name);
 	               if (trend[i] != trend[i+1])
 	               {
 	                  color theColor  = LinesUpColor; if (trend[i]==-1) theColor = LinesDnColor;
 	                   ObjectCreate(name,OBJ_VLINE,window,Time[i],0);
 	                      ObjectSet(name,OBJPROP_WIDTH,LinesWidth);
 	                      ObjectSet(name,OBJPROP_STYLE,LinesStyle);
 	                      ObjectSet(name,OBJPROP_COLOR,theColor);
 	               }
 	         }  
   }
   
   //
   //
   //
   //
   //
      
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
      if (trend[whichBar] != trend[whichBar+1])
      if (trend[whichBar] == 1)
            doAlert("crossing signal up");
      else  doAlert("crossing signal down");       
   }
return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," StochasticDiNapoli ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," StochasticDiNapoli  "),message);
             if (alertsSound)   PlaySound(soundFile);
      }
}
      
